#
# Modified from https://github.com/mandiant/RProxy/blob/master/CMakeModules/FindLibEvent.cmake
#

# LIBEVENT_FOUND - System has LibEvent
# LIBEVENT_INCLUDE_DIR - the LibEvent include directory
# LIBEVENT_LIBRARIES 0 The libraries needed to use LibEvent

FIND_PATH(LIBEVENT_INCLUDE_DIR
          NAMES event.h
          PATHS ${LIBEVENT_ROOT}/include)
if (STATIC_BUILD)
  FIND_LIBRARY(LIBEVENT_LIBRARY
               NAMES libevent.a
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_CORE_LIBRARY
               NAMES libevent_core.a
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_PTHREADS_LIBRARY
               NAMES libevent_pthreads.a
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_EXTRA_LIBRARY
               NAMES libevent_extra.a
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_OPENSSL_LIBRARY
               NAMES libevent_openssl.a
               PATHS ${LIBEVENT_ROOT}/lib)
else ()
  FIND_LIBRARY(LIBEVENT_LIBRARY
               NAMES event
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_CORE_LIBRARY
               NAMES event_core
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_PTHREADS_LIBRARY
               NAMES event_pthreads
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_EXTRA_LIBRARY
               NAMES event_extra
               PATHS ${LIBEVENT_ROOT}/lib)
  FIND_LIBRARY(LIBEVENT_OPENSSL_LIBRARY
               NAMES event_openssl
               PATHS ${LIBEVENT_ROOT}/lib)
endif ()

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LibEvent DEFAULT_MSG LIBEVENT_LIBRARY LIBEVENT_INCLUDE_DIR)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LibEventPthreads DEFAULT_MSG LIBEVENT_PTHREADS_LIBRARY LIBEVENT_INCLUDE_DIR)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LibEventCore DEFAULT_MSG LIBEVENT_CORE_LIBRARY LIBEVENT_INCLUDE_DIR)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LibEventExtra DEFAULT_MSG LIBEVENT_EXTRA_LIBRARY LIBEVENT_INCLUDE_DIR)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LibEventOpenssl DEFAULT_MSG LIBEVENT_OPENSSL_LIBRARY LIBEVENT_INCLUDE_DIR)

MARK_AS_ADVANCED(LIBEVENT_INCLUDE_DIR LIBEVENT_LIBRARY LIBEVENT_PTHREADS_LIBRARY LIBEVENT_OPENSSL_LIBRARY LIBEVENT_CORE_LIBRARY LIBEVENT_EXTRA_LIBRARY)

if (NOT LIBEVENT_FOUND)
  message(FATAL_ERROR "LibEvent is required. You may use LIBEVENT_ROOT to specify the root path of the LibEvent")
endif()
